import { Either } from 'trimop';
import { Doc, Field, WriteDoc, WriteField } from './data';
/**
 * ApplyDocWriteError
 */
export declare type ApplyDocWriteError = {
    readonly expectedFieldTypes: readonly (Field['_type'] | 'undefined')[];
    readonly field: Field | undefined;
};
export declare function ApplyDocWriteError(p: ApplyDocWriteError): ApplyDocWriteError;
/**
 *
 * @param param0
 * @returns
 */
export declare function applyFieldWrite({ field, writeField, }: {
    readonly field: Field | undefined;
    readonly writeField: WriteField;
}): Either<ApplyDocWriteError, Field>;
export declare function applyDocWrite({ doc, writeDoc, }: {
    readonly doc: Doc | undefined;
    readonly writeDoc: WriteDoc;
}): Either<ApplyDocWriteError, Doc>;
//# sourceMappingURL=apply-doc-write.d.ts.map